import { world, BlockPermutation, ItemStack } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_sculk_sound', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk @a[r=16] ~ ~ ~ 1 0.8")
        }
    }
    ,);
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_dark_sculk_sound', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 0.8")
        }
    }
    ,);
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_sculk_jaw', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("event entity @e [type=warden_evo:sculk_jaw_active,r=6,c=1] despawn")
        }
    }
    ,);
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_injured_block', {
        onPlayerDestroy({ player }) {
            player.runCommandAsync("event entity @e [type=warden_evo:injured_block_active,r=6,c=1] despawn")
        }
    }
    ,);
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_sculk_vein_sound', {
        onPlayerDestroy: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.sculk_vein @a[r=16] ~ ~ ~ 1 0.8")
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_dark_sculk_vein_sound', {
        onPlayerDestroy: e => {
            const { player } = e;
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 0.8")
        }
    });
});

//BONE SCULK
//Bone Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_bone_sculk_catalyst', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_catalyst_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_catalyst_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Bone Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_bone_sculk_shrieker', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk_shrieker @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_shrieker_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_shrieker_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Bone Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_bone_sculk_sensor', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk_sensor @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_sensor_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:bone_sculk_sensor_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//DARK SCULK
//Dark Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_dark_sculk_catalyst', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_catalyst_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_catalyst_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Dark Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_dark_sculk_shrieker', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_shrieker_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_shrieker_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Dark Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_dark_sculk_sensor', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound place.dark_sculk @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_sensor_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:dark_sculk_sensor_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//HOLLOW SCULK
//Hollow Sculk Catalyst
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_hollow_sculk_catalyst', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_catalyst_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_catalyst_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Hollow Sculk Shrieker
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_hollow_sculk_shrieker', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk_shrieker @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_shrieker_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_shrieker_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Hollow Sculk Sensor
world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_hollow_sculk_sensor', {
        onPlayerDestroy({ block, player }) {
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            block.dimension.spawnEntity(('minecraft:xp_orb'), block.location);
            player.runCommandAsync("playsound break.sculk_sensor @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_sensor_inactive,r=6,c=1] despawn")
            player.runCommandAsync("event entity @e [type=warden_evo:hollow_sculk_sensor_active,r=6,c=1] despawn")
        }
    }
    ,);
});

//Magic Gem Crystal
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_destroy_magic_gem_crystal', {
        onPlayerDestroy: e => {
            const { player } = e;
            player.runCommandAsync("playsound break.amethyst_block @a[r=16] ~ ~ ~ 1 0.8")
            player.runCommandAsync("event entity @e [type=warden_evo:magic_gem_lb,r=6,c=1] remove_effects")
            player.runCommandAsync("event entity @e [type=warden_evo:magic_gem_fake_lb,r=6,c=1] remove_effects")
        }
    });
});