import { world } from '@minecraft/server';

//Events when step on blocks 

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_sculk_sound', {
        onStepOn: e => {
            const { block } = e;
            block.dimension.playSound('step.mixed_sculk', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_dark_sculk_sound', {
        onStepOn: e => {
            const { block } = e;
            block.dimension.playSound('step.dark_sculk', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_sculk_shrieker_sound', {
        onStepOn: e => {
            const { block } = e;
            block.dimension.playSound('step.mixed_sculk_shrieker', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_sculk_sensor_sound', {
        onStepOn: e => {
            const { block } = e;
            block.dimension.playSound('step.mixed_sculk_sensor', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_sculk_vein_sound', {
        onStepOn: e => {
            const { block } = e;
            block.dimension.playSound('step.mixed_sculk_vein', block.location)
        }
    });
});

//Injured Block
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_injured_block', {
        onStepOn: e => {
            const { block } = e;
            block.setType('warden_evo:injured_block_active');
        }
    });
});

//Sculk Jaw
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_step_sculk_jaw', {
        onStepOn: e => {
            const { block } = e;
            block.setType('warden_evo:sculk_jaw_active');
        }
    });
});


//Events when they fall on the blocks

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_sculk_sound', {
        onEntityFallOn: e => {
            const { block } = e;
            block.dimension.playSound('fall.mixed_sculk', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_dark_sculk_sound', {
        onEntityFallOn: e => {
            const { block } = e;
            block.dimension.playSound('fall.dark_sculk', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_sculk_shrieker_sound', {
        onEntityFallOn: e => {
            const { block } = e;
            block.dimension.playSound('fall.mixed_sculk_shrieker', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_sculk_sensor_sound', {
        onEntityFallOn: e => {
            const { block } = e;
            block.dimension.playSound('fall.mixed_sculk_sensor', block.location)
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_sculk_vein_sound', {
        onEntityFallOn: e => {
            const { block } = e;
            block.dimension.playSound('fall.mixed_sculk_vein', block.location)
        }
    });
});

//Injured Block
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_injured_block', {
        onEntityFallOn: e => {
            const { block } = e;
            block.setType('warden_evo:injured_block_active');
        }
    });
});

//Sculk Jaw
world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('warden_evo:on_fall_sculk_jaw', {
        onEntityFallOn: e => {
            const { block } = e;
            block.setType('warden_evo:sculk_jaw_active');
        }
    });
});